﻿namespace TestProject
{
    /// <summary>
    /// 일별거래상세요청
    /// </summary>
    public class 일별거래상세요청 : TransactionDataRequest<일별거래상세항목>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - 일별거래상세요청(messageForm, hts, dataType)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="messageForm">메시지 폼</param>
        /// <param name="hts">HTS</param>
        /// <param name="dataType">트랜잭션 데이터 타입</param>
        public 일별거래상세요청
        (
            IMessageForm               messageForm,
            AxKHOpenAPILib.AxKHOpenAPI hts,
            TransactionDataType        dataType
        ) : base(messageForm, hts, "일별거래상세", "OPT10015", "0001", dataType)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected
        //////////////////////////////////////////////////////////////////////////////// Function

        #region 항목 구하기 - GetItem(e, index)

        /// <summary>
        /// 항목 구하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        /// <param name="index">인덱스</param>
        /// <returns>항목</returns>
        protected override 일별거래상세항목 GetItem(AxKHOpenAPILib._DKHOpenAPIEvents_OnReceiveTrDataEvent e, int index)
        {
            string 일자             = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "일자"            ).Trim();
            string 종가             = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "종가"            ).Trim();
            string 전일대비기호     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "전일대비기호"    ).Trim();
            string 전일대비         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "전일대비"        ).Trim();
            string 등락율           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "등락율"          ).Trim();
            string 거래량           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "거래량"          ).Trim();
            string 거래대금         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "거래대금"        ).Trim();
            string 장전거래량       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장전거래량"      ).Trim();
            string 장전거래비중     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장전거래비중"    ).Trim();
            string 장중거래량       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장중거래량"      ).Trim();
            string 장중거래비중     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장중거래비중"    ).Trim();
            string 합계3            = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "합계3"           ).Trim();
            string 기간중거래량     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "기간중거래량"    ).Trim();
            string 체결강도         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "체결강도"        ).Trim();
            string 외인보유         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "외인보유"        ).Trim();
            string 외인비중         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "외인비중"        ).Trim();
            string 외인순매수       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "외인순매수"      ).Trim();
            string 기관순매수       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "기관순매수"      ).Trim();
            string 개인순매수       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "개인순매수"      ).Trim();
            string 외국계           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "외국계"          ).Trim();
            string 신용잔고율       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "신용잔고율"      ).Trim();
            string 프로그램         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "프로그램"        ).Trim();
            string 장전거래대금     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장전거래대금"    ).Trim();
            string 장전거래대금비중 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장전거래대금비중").Trim();
            string 장중거래대금     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장중거래대금"    ).Trim();
            string 장중거래대금비중 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장중거래대금비중").Trim();
            string 장후거래대금     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장후거래대금"    ).Trim();
            string 장후거래대금비중 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "장후거래대금비중").Trim();

            일별거래상세항목 item = new 일별거래상세항목();

            item.일자             = 일자;
            item.종가             = 종가;
            item.전일대비기호     = 전일대비기호;
            item.전일대비         = 전일대비;
            item.등락율           = 등락율;
            item.거래량           = 거래량;
            item.거래대금         = 거래대금;
            item.장전거래량       = 장전거래량;
            item.장전거래비중     = 장전거래비중;
            item.장중거래량       = 장중거래량;
            item.장중거래비중     = 장중거래비중;
            item.합계3            = 합계3;
            item.기간중거래량     = 기간중거래량;
            item.체결강도         = 체결강도;
            item.외인보유         = 외인보유;
            item.외인비중         = 외인비중;
            item.외인순매수       = 외인순매수;
            item.기관순매수       = 기관순매수;
            item.개인순매수       = 개인순매수;
            item.외국계           = 외국계;
            item.신용잔고율       = 신용잔고율;
            item.프로그램         = 프로그램;
            item.장전거래대금     = 장전거래대금;
            item.장전거래대금비중 = 장전거래대금비중;
            item.장중거래대금     = 장중거래대금;
            item.장중거래대금비중 = 장중거래대금비중;
            item.장후거래대금     = 장후거래대금;
            item.장후거래대금비중 = 장후거래대금비중;

            return item;
        }

        #endregion
    }
}