﻿namespace TestProject
{
    /// <summary>
    /// 주식기본정보요청
    /// </summary>
    public class 주식기본정보요청 : TransactionDataRequest<주식기본정보항목>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - 주식기본정보요청(messageForm, hts)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="messageForm">메시지 폼</param>
        /// <param name="hts">HTS</param>
        public 주식기본정보요청
        (
            IMessageForm               messageForm,
            AxKHOpenAPILib.AxKHOpenAPI hts
        ) : base(messageForm, hts, "주식기본정보", "OPT10001", "0001", TransactionDataType.Single)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected
        //////////////////////////////////////////////////////////////////////////////// Function

        #region 항목 구하기 - GetItem(e, index)

        /// <summary>
        /// 항목 구하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        /// <param name="index">인덱스</param>
        /// <returns>항목</returns>
        protected override 주식기본정보항목 GetItem(AxKHOpenAPILib._DKHOpenAPIEvents_OnReceiveTrDataEvent e, int index)
        {
            string 종목코드         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "종목코드"       ).Trim();
            string 종목명           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "종목명"         ).Trim();
            string 결산월           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "결산월"         ).Trim();
            string 액면가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "액면가"         ).Trim();
            string 자본금           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "자본금"         ).Trim();
            string 상장주식         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "상장주식"       ).Trim();
            string 신용비율         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "신용비율"       ).Trim();
            string 연중최고         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "연중최고"       ).Trim();
            string 연중최저         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "연중최저"       ).Trim();
            string 시가총액         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "시가총액"       ).Trim();
            string 시가총액비중     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "시가총액비중"   ).Trim();
            string 외인소진률       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "외인소진률"     ).Trim();
            string 대용가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "대용가"         ).Trim();
            string PER              = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "PER"            ).Trim();
            string EPS              = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "EPS"            ).Trim();
            string ROE              = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "ROE"            ).Trim();
            string PBR              = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "PBR"            ).Trim();
            string EV               = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "EV"             ).Trim();
            string BPS              = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "BPS"            ).Trim();
            string 매출액           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "매출액"         ).Trim();
            string 영업이익         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "영업이익"       ).Trim();
            string 당기순이익       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "당기순이익"     ).Trim();
            string D250최고         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최고"        ).Trim();
            string D250최저         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최저"        ).Trim();
            string 시가             = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "시가"           ).Trim();
            string 고가             = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "고가"           ).Trim();
            string 저가             = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "저가"           ).Trim();
            string 상한가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "상한가"         ).Trim();
            string 하한가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "하한가"         ).Trim();
            string 기준가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "기준가"         ).Trim();
            string 예상체결가       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "예상체결가"     ).Trim();
            string 예상체결수량     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "예상체결수량"   ).Trim();
            string D250최고가일     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최고가일"    ).Trim();
            string D250최고가대비율 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최고가대비율").Trim();
            string D250최저가일     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최저가일"    ).Trim();
            string D250최저가대비율 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "250최저가대비율").Trim();
            string 현재가           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "현재가"         ).Trim();
            string 대비기호         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "대비기호"       ).Trim();
            string 전일대비         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "전일대비"       ).Trim();
            string 등락율           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "등락율"         ).Trim();
            string 거래량           = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "거래량"         ).Trim();
            string 거래대비         = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "거래대비"       ).Trim();
            string 액면가단위       = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, 0, "액면가단위"     ).Trim();

            주식기본정보항목 item = new 주식기본정보항목();

            item.종목코드         = 종목코드;
            item.종목명           = 종목명;
            item.결산월           = 결산월;
            item.액면가           = 액면가;
            item.자본금           = 자본금;
            item.상장주식         = 상장주식;
            item.신용비율         = 신용비율;
            item.연중최고         = 연중최고;
            item.연중최저         = 연중최저;
            item.시가총액         = 시가총액;
            item.시가총액비중     = 시가총액비중;
            item.외인소진률       = 외인소진률;
            item.대용가           = 대용가;
            item.PER              = PER;
            item.EPS              = EPS;
            item.ROE              = ROE;
            item.PBR              = PBR;
            item.EV               = EV;
            item.BPS              = BPS;
            item.매출액           = 매출액;
            item.영업이익         = 영업이익;
            item.당기순이익       = 당기순이익;
            item.D250최고         = D250최고;
            item.D250최저         = D250최저;
            item.시가             = 시가;
            item.고가             = 고가;
            item.저가             = 저가;
            item.상한가           = 상한가;
            item.하한가           = 하한가;
            item.기준가           = 기준가;
            item.예상체결가       = 예상체결가;
            item.예상체결수량     = 예상체결수량;
            item.D250최고가일     = D250최고가일;
            item.D250최고가대비율 = D250최고가대비율;
            item.D250최저가일     = D250최저가일;
            item.D250최저가대비율 = D250최저가대비율;
            item.현재가           = 현재가;
            item.대비기호         = 대비기호;
            item.전일대비         = 전일대비;
            item.등락율           = 등락율;
            item.거래량           = 거래량;
            item.거래대비         = 거래대비;
            item.액면가단위       = 액면가단위;

            return item;
        }

        #endregion
    }
}