﻿namespace TestProject
{
    /// <summary>
    /// 주식일봉차트조회요청
    /// </summary>
    public class 주식일봉차트조회요청 : TransactionDataRequest<주식일봉차트항목>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - 주식일봉차트조회요청(messageForm, hts, dataType)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="messageForm">메시지 폼</param>
        /// <param name="hts">HTS</param>
        /// <param name="dataType">트랜잭션 데이터 타입</param>
        public 주식일봉차트조회요청
        (
            IMessageForm               messageForm,
            AxKHOpenAPILib.AxKHOpenAPI hts,
            TransactionDataType        dataType
        ) : base(messageForm, hts, "주식일봉차트조회", "OPT10081", "0001", dataType)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected
        //////////////////////////////////////////////////////////////////////////////// Function

        #region 항목 구하기 - GetItem(e, index)

        /// <summary>
        /// 항목 구하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        /// <param name="index">인덱스</param>
        /// <returns>항목</returns>
        protected override 주식일봉차트항목 GetItem(AxKHOpenAPILib._DKHOpenAPIEvents_OnReceiveTrDataEvent e, int index)
        {
            string 현재가   = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "현재가"  ).Trim();
            string 거래량   = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "거래량"  ).Trim();
            string 거래대금 = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "거래대금").Trim();
            string 일자     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "일자"    ).Trim();
            string 시가     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "시가"    ).Trim();
            string 고가     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "고가"    ).Trim();
            string 저가     = this.hts.CommGetData(e.sTrCode, string.Empty, e.sRQName, index, "저가"    ).Trim();

            주식일봉차트항목 item = new 주식일봉차트항목();

            item.현재가   = 현재가;
            item.거래량   = 거래량;
            item.거래대금 = 거래대금;
            item.일자     = 일자;
            item.시가     = 시가;
            item.고가     = 고가;
            item.저가     = 저가;

            return item;
        }

        #endregion
    }
}